--[[
###############
Inked: keivamp#
###############
]]--
local Inked = LibStub("AceAddon-3.0"):GetAddon("Inked")
local LSM = LibStub("LibSharedMedia-3.0")

local playerColor = RAID_CLASS_COLORS[select(2, UnitClass('player'))]
local InkedColors = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 1}
local InkedColorsHightlight = {r = playerColor.r*0.75, g = playerColor.g*0.75,b = playerColor.b*0.75,a = 0.1}

local HightlightTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsHoverTex"
local PushedTex = "Interface\\Addons\\Inked\\Graphics\\Buttons\\AB_ButtonsPushedTex"
local CountFont = "Interface\\Addons\\Inked\\Fonts\\SF Comic Script.ttf"
local CountFontSize = 13
local CountFontOutline = "OUTLINE"
local NameFont = "Interface\\Addons\\Inked\\Fonts\\Roboto.ttf"
local NameFontSize = 9
local NameFontOutline = "THINOUTLINE"

local ButtonSize = 40
local MySpacing = 1
local BorderSize = 12
local BorderPadding = 0

local MoverAB9 = CreateFrame("Frame","AB9Drag",UIParent, BackdropTemplateMixin and "BackdropTemplate")
	MoverAB9:SetSize((ButtonSize * 12)+12, ButtonSize)
	--MoverAB9:SetPoint("CENTER", UIParent,"BOTTOM",220.5, 65.5)
	MoverAB9:SetFrameStrata("FULLSCREEN_DIALOG")
	MoverAB9:SetClampedToScreen(true)
	MoverAB9:SetClampRectInsets(0, 0, 0,0)
local MoverAB9Text  = MoverAB9:CreateFontString(nil, "OVERLAY")
	MoverAB9Text:SetFont("Interface\\Addons\\Inked\\Fonts\\Cooline.TTF", 15, "OUTLINE")
	MoverAB9Text:SetPoint("CENTER",MoverAB9,"CENTER", 0,0); 
	MoverAB9Text:SetText("")
	
	local function CreateButtonTexture(frame)
	local ButtonForeground = CreateFrame("Frame","ButtonForegroundTexture",frame, BackdropTemplateMixin and "BackdropTemplate")
		  ButtonForeground:SetAllPoints(frame)
		  ButtonForeground:SetFrameLevel(4)
		  ButtonForeground:SetBackdrop({bgFile = "Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButton",
			edgeFile = "Interface\\Addons\\Inked\\Graphics\\Borders\\InkedBorder",
			edgeSize = 16,
			insets = {top = 4, left = 4, bottom = 4, right = 4}})
		ButtonForeground:SetBackdropColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
		ButtonForeground:SetBackdropBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,0)
end

local function UpdateMe()
	if(Inked.db.profile.lockframes == false) then
		if Inked.db.profile.AB9Enable == true then
			local point, relativeTo, relativePoint, xOfs, yOfs = MoverAB9:GetPoint(n)
				Inked.db.profile.MoverAB9X = xOfs
				Inked.db.profile.MoverAB9Y = yOfs
				Inked.db.profile.MoverAB9Point = point
				--Inked.db.profile.MoverAB9RelPoint = relativePoint
				--print(point.." "..relativePoint)
				MoverAB9Text:SetText("Inked Bar 9")	
		end		
	end	
end	

local InkedSettingsFrame = CreateFrame("Frame")	
	InkedSettingsFrame:HookScript("OnUpdate",UpdateMe) 
	
local function CreateMoverBackdrop(frame)
	frame:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8x8",
	insets = {top = -2, left = -2, bottom = -2, right = -2}})
	frame:SetBackdropColor(0,0.55,0.95,0.45)
	frame:SetBackdropBorderColor(0,0,0,1)
end



local function MakeBar9()
	if Inked.db.profile.UseActionBars == false then return end
	if UnitClass("player") == "Druid" then return end
	local InkedBar9 = CreateFrame("Frame", nil, UIParent, BackdropTemplateMixin and "BackdropTemplate")
	InkedBar9:SetAllPoints(MoverAB9)

	ButtonSize = Inked.db.profile.AB9ButtonSize
	local ThisTexture = ("Interface\\Addons\\Inked\\Graphics\\Buttons\\InkedButtons")
		InkedBar9config = {
				outOfRangeColoring = "button",
				tooltip = "enabled",
				showGrid = true,
				colors = {
					range = { 0.8, 0.1, 0.1 },
					mana = { 0.5, 0.5, 1.0 }
				},
				hideElements = {
					macro = false,
					hotkey = false,
					equipped = false,
				},
				keyBoundTarget = false,
				clickOnDown = false,
				flyoutDirection = "UP",	
			}
		CreateFrame("Frame", "InkedActionBar9", UIParent, "SecureHandlerStateTemplate")
		InkedActionBar9:SetParent(InkedBar9)
		InkedActionBar9:SetPoint("RIGHT", InkedBar9,"LEFT",ButtonSize/2,0)
		RegisterStateDriver(InkedActionBar9, "vehicle", "[petbattle][overridebar] hide;show")	
		InkedActionBar9:SetAttribute("_onstate-vehicle", [[
			if newstate == "hide" then
			  self:Hide();
			else
			  self:Show();
			end
		]]) 
		--local ButtonSize = Inked.db.profile.ButtonSize
		--local lastnumber = 97 + Inked.db.profile.Bar7ButtonNumber
		local lastnumber = 97 + 12

			

	if Inked.db.profile.AB9Enable == true then
		InkedBar9:Show()
		if Inked.db.profile.Bar9BarLayout == 1 then
					for i = 97,lastnumber-1 do -- bar 1
						local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
						Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*(ButtonSize+MySpacing*1.5),0)
						Inkedbutton9:Show()
						Inkedbutton9:SetState(0, "action", i)
						Inkedbutton9:SetSize(ButtonSize,ButtonSize)
						Inkedbutton9:SetAttribute("buttonlock",true)
						Inkedbutton9:SetAttribute("checkselfcast",true)
						Inkedbutton9:SetAttribute("checkfocuscast",true)
						Inkedbutton9:UpdateConfig(InkedBar9config)
					end
				--	InkedActionBar9:SetPoint("LEFT", InkedBar9,0,0)
				elseif Inked.db.profile.Bar9BarLayout == 2 then
					MoverAB9:SetSize(ButtonSize*6, ButtonSize* 2)
					InkedActionBar9:SetPoint("LEFT", InkedBar9,4,20)
					if lastnumber > 102 then
						for i = 97,102 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*ButtonSize,0)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end
						for i = 103,lastnumber-1 do -- bar 1
							local Inkedbutton9a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9a:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-103)*ButtonSize,-(ButtonSize+1))
							Inkedbutton9a:Show()
							Inkedbutton9a:SetState(0, "action", i)
							Inkedbutton9a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9a:SetAttribute("buttonlock",true)
							Inkedbutton9a:SetAttribute("checkselfcast",true)
							Inkedbutton9a:SetAttribute("checkfocuscast",true)
							Inkedbutton9a:UpdateConfig(InkedBar9config)
						end
					else
						for i = 97,lastnumber-1 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*ButtonSize,0)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end					
					end
							
				elseif Inked.db.profile.Bar9BarLayout == 3 then
					MoverAB9:SetSize(ButtonSize*4, ButtonSize* 3)
					InkedActionBar9:SetPoint("LEFT", InkedBar9,8,33)
					if lastnumber > 100 then
						for i = 97,100 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*ButtonSize,0)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end
						for i = 101,104 do -- bar 1
							local Inkedbutton9a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9a:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-101)*ButtonSize,-(ButtonSize+1))
							Inkedbutton9a:Show()
							Inkedbutton9a:SetState(0, "action", i)
							Inkedbutton9a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9a:SetAttribute("buttonlock",true)
							Inkedbutton9a:SetAttribute("checkselfcast",true)
							Inkedbutton9a:SetAttribute("checkfocuscast",true)
							Inkedbutton9a:UpdateConfig(InkedBar9config)
						end
						for i = 105,lastnumber-1 do -- bar 1
							local Inkedbutton9b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9b:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-105)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton9b:Show()
							Inkedbutton9b:SetState(0, "action", i)
							Inkedbutton9b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9b:SetAttribute("buttonlock",true)
							Inkedbutton9b:SetAttribute("checkselfcast",true)
							Inkedbutton9b:SetAttribute("checkfocuscast",true)
							Inkedbutton9b:UpdateConfig(InkedBar9config)
						end
					else
						for i = 97,lastnumber-1 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*ButtonSize,0)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end					
					end
				
				elseif Inked.db.profile.Bar9BarLayout == 4 then
					InkedActionBar9:SetPoint("TOPLEFT", InkedBar9,"BOTTOMRIGHT",-15,15)
					MoverAB9:SetSize(ButtonSize, ButtonSize* 12)
					for i = 97,lastnumber-1 do -- bar 1
						local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
						Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",0,(i-97)*ButtonSize)
						Inkedbutton9:Show()
						Inkedbutton9:SetState(0, "action", i)
						Inkedbutton9:SetSize(ButtonSize,ButtonSize)
						Inkedbutton9:SetAttribute("buttonlock",true)
						Inkedbutton9:SetAttribute("checkselfcast",true)
						Inkedbutton9:SetAttribute("checkfocuscast",true)
						Inkedbutton9:UpdateConfig(InkedBar9config)
					end
				elseif Inked.db.profile.Bar9BarLayout == 5 then
					MoverAB9:SetSize(ButtonSize*2, ButtonSize* 6)
					InkedActionBar9:SetPoint("TOPLEFT", InkedBar9,"BOTTOMRIGHT",10,15)
					if lastnumber > 102 then
						for i = 97,102 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",0,(i-97)*ButtonSize)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end
						for i = 103,lastnumber-1 do -- bar 1
							local Inkedbutton9a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9a:SetPoint("CENTER", InkedActionBar9,"CENTER",-ButtonSize,(i-103)*ButtonSize)
							Inkedbutton9a:Show()
							Inkedbutton9a:SetState(0, "action", i)
							Inkedbutton9a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9a:SetAttribute("buttonlock",true)
							Inkedbutton9a:SetAttribute("checkselfcast",true)
							Inkedbutton9a:SetAttribute("checkfocuscast",true)
							Inkedbutton9a:UpdateConfig(InkedBar9config)
						end
					else
						for i = 97,lastnumber-1 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*ButtonSize,0)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end					
					end
				
				elseif Inked.db.profile.Bar9BarLayout == 6 then
					MoverAB9:SetSize(ButtonSize*3, ButtonSize*4)
					InkedActionBar9:SetPoint("LEFT", InkedBar9,10,52)
					if lastnumber > 99 then
						for i = 97,99 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*ButtonSize,0)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end
						for i = 100,102 do -- bar 1
							local Inkedbutton9a = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9a:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-100)*ButtonSize,-(ButtonSize+1))
							Inkedbutton9a:Show()
							Inkedbutton9a:SetState(0, "action", i)
							Inkedbutton9a:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9a:SetAttribute("buttonlock",true)
							Inkedbutton9a:SetAttribute("checkselfcast",true)
							Inkedbutton9a:SetAttribute("checkfocuscast",true)
							Inkedbutton9a:UpdateConfig(InkedBar9config)
						end
						for i = 103,105 do -- bar 1
							local Inkedbutton9b = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9b:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-103)*ButtonSize,-(ButtonSize+1)*2)
							Inkedbutton9b:Show()
							Inkedbutton9b:SetState(0, "action", i)
							Inkedbutton9b:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9b:SetAttribute("buttonlock",true)
							Inkedbutton9b:SetAttribute("checkselfcast",true)
							Inkedbutton9b:SetAttribute("checkfocuscast",true)
							Inkedbutton9b:UpdateConfig(InkedBar9config)
						end
						for i = 106,lastnumber-1 do -- bar 1
							local Inkedbutton9c = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9c:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-106)*ButtonSize,-(ButtonSize+1)*3)
							Inkedbutton9c:Show()
							Inkedbutton9c:SetState(0, "action", i)
							Inkedbutton9c:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9c:SetAttribute("buttonlock",true)
							Inkedbutton9c:SetAttribute("checkselfcast",true)
							Inkedbutton9c:SetAttribute("checkfocuscast",true)
							Inkedbutton9c:UpdateConfig(InkedBar9config)
						end
					else
						for i = 97,lastnumber-1 do -- bar 1
							local Inkedbutton9 = LibStub("LibActionButton-1.0"):CreateButton(1, "InkedbuttonBar"..i, InkedActionBar9)
							Inkedbutton9:SetPoint("CENTER", InkedActionBar9,"CENTER",(i-97)*ButtonSize,0)
							Inkedbutton9:Show()
							Inkedbutton9:SetState(0, "action", i)
							Inkedbutton9:SetSize(ButtonSize,ButtonSize)
							Inkedbutton9:SetAttribute("buttonlock",true)
							Inkedbutton9:SetAttribute("checkselfcast",true)
							Inkedbutton9:SetAttribute("checkfocuscast",true)
							Inkedbutton9:UpdateConfig(InkedBar9config)
						end					
					end
				
				end -- end folds
					for i = 97,108 do -- bar 6
							local normalBar9 = _G["InkedbuttonBar"..i]							
						--	CreateButtonTexture(normalBar9)
							normalBar9.NormalTexture:SetTexture("")
							local Highlight = normalBar9:GetHighlightTexture()						
							local Pushed = normalBar9:GetPushedTexture()
							Highlight:SetTexture(HightlightTex)
							Highlight:SetVertexColor(InkedColorsHightlight.r,InkedColorsHightlight.g,InkedColorsHightlight.b,InkedColorsHightlight.a)
							Pushed:SetTexture(PushedTex)							
							local count = _G[normalBar9:GetName()..'Count']
							count:SetFont(CountFont,CountFontSize,CountFontOutline)
							local name = _G[normalBar9:GetName()..'Name']
							name:SetWidth(55)
							name:SetFont(NameFont,NameFontSize,NameFontOutline)
							normalBar9:CreateBeautyBorder(BorderSize)
							normalBar9:SetBeautyBorderPadding(BorderPadding)
							normalBar9:SetBeautyBorderTexture("white")
							--normalBar9:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							if Inked.db.profile.ClassABColor == true then
								normalBar9:SetBeautyBorderColor(InkedColors.r,InkedColors.g,InkedColors.b,1)
							elseif Inked.db.profile.ClassABColor == false then
								if Inked.db.profile.CustomABColor == true then
									normalBar9:SetBeautyBorderColor(Inked.db.profile.ABColorR,Inked.db.profile.ABColorG,Inked.db.profile.ABColorB,Inked.db.profile.ABColorA)
								elseif Inked.db.profile.CustomABColor == false then
									normalBar9:SetBeautyBorderColor(1,1,1,1)
								end
							end
		
						end
		end
		if(Inked.db.profile.lockframes == false) then
			MoverAB9:ClearAllPoints()
			if Inked.db.profile.MoverAB9Point == nil then
				MoverAB9:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB9X,Inked.db.profile.MoverAB9Y)
			else
				MoverAB9:SetPoint(Inked.db.profile.MoverAB9Point, UIParent,Inked.db.profile.MoverAB9X,Inked.db.profile.MoverAB9Y)
			end
			if Inked.db.profile.AB9Enable == true then
				CreateMoverBackdrop(MoverAB9)
				MoverAB9:SetMovable(true)
				MoverAB9:EnableMouse(true)
				MoverAB9:RegisterForDrag("LeftButton")
				MoverAB9:SetScript("OnDragStart", MoverAB9.StartMoving)
				MoverAB9:SetScript("OnDragStop", MoverAB9.StopMovingOrSizing)
				MoverAB9:SetUserPlaced(true)
			end
			elseif Inked.db.profile.MoverAB9Point == nil then
				MoverAB9:SetPoint("BOTTOM", UIParent,Inked.db.profile.MoverAB9X,Inked.db.profile.MoverAB9Y)
			else
				MoverAB9:SetPoint(Inked.db.profile.MoverAB9Point, UIParent,Inked.db.profile.MoverAB9X,Inked.db.profile.MoverAB9Y)
		end
end		
		local InkedLoginFrame=CreateFrame("Frame")
		InkedLoginFrame:RegisterEvent("PLAYER_LOGIN")
		InkedLoginFrame:RegisterEvent("CINEMATIC_STOP")
		InkedLoginFrame:SetScript("OnEvent", function(self, event) 
			MakeBar9()									
		end)